<template>
  <div>
    <el-table
      :data="nodes"
      border
      :header-cell-style="changeHead"
      style="width: 500px">
      <el-table-column :label="$t('QUESTION.KEYWORD')" align="center">
        <template slot-scope="scope">
          <div>
            {{ scope.row.label }}
          </div>
        </template>
      </el-table-column>
      <el-table-column :label="$t('MAP.IMPORTANCE')" align="center">
        <template slot-scope="scope">
          <div v-if="inputFlag[scope.$index]">
            <div style="display:inline-block; width: 100px">
              <el-input type="number" step="1" v-model="nodes[scope.$index].weight" />
            </div>
            <el-button @click="onClick('saveNodeWeight', scope.$index)">{{ $t('NOTE.CONFIRM') }}</el-button>
          </div>
          <div v-else>
            {{ scope.row.weight }}<i class="el-icon-edit" @click="onClick('changeNodeWeight', scope.$index)" />
          </div>
        </template>
      </el-table-column>
    </el-table>
  </div>
</template>

<script>
import { mapState } from 'vuex';

export default {
  name: 'KnowledgeMapNodeEditor',
  props: ['updateNodeData'],
  data() {
    return {
      inputFlag: [],
    };
  },
  computed: {
    ...mapState('kMap', [
      'nodes',
    ]),
  },
  methods: {
    onClick(type, index) {
      const vm = this;
      switch (type) {
        case 'changeNodeWeight': {
          // https://kr.vuejs.org/v2/guide/reactivity.html '배열의 변화를 감지하기 위해 직접 대입 대신 이 함수를 사용함'
          vm.checkAndCreateInputFlag(index);
          vm.inputFlag.splice(index, 1, true);
          break;
        }
        case 'saveNodeWeight': {
          const node = vm.nodes[index];
          // eslint-disable-next-line
          if (node.weight < 1 || node.weight > 100) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ENTER_ONE_THOU'),
              type: 'warning',
            });
            vm.nodes[index].weight = 20; // eslint-disable-line
            break;
          }
          vm.updateNodeData(index);
          vm.inputFlag.splice(index, 1, false);
          break;
        }
        default: {
          throw new Error('not defined type', type);
        }
      }
    },
    checkAndCreateInputFlag(index) {
      const vm = this;
      if (vm.inputFlag[index] === undefined) {
        vm.inputFlag[index] = null;
        vm.inputFlag.splice(index, 1);
      }
    },
    changeHead() {
      return { backgroundColor: '#ebeef5' };
    },
  },
};
</script>
